#include <stdio.h>

int main(int argc,char* argv[])
{
  FILE *in, *out;
  char *p, *q, *r;
  int c, d, width, height, i, j, fsize, cl, cr, ct, cb;
  if (argc<2)	{
printusage:  printf("USAGE: cut4mrp.exe inputfile outputfile\n" "Input file must be an 8-bit image in PNM format\n"), exit(0);
		}

   in = fopen(argv[1],"rb");  if (  in==0 )  printf("can't open inputfile\n"), exit(1);
  out = fopen(argv[2],"wb");  if ( out==0 )  printf("can't open outputfile\n"), exit(1);

  fseek(in, 0L, SEEK_END);
  fsize = ftell(in);
  fseek(in, 0, SEEK_SET);
  p=q=(char*)malloc(fsize);
  i=fread(p, 1, fsize, in);  if (i!=fsize) printf("can't read from inputfile\n"), exit(1);

  c=*q++, d=*q++;  if (c!='P' || d!='5') goto printusage;

#define Read_and_modify(var)\
  do { c=*++q; } while (!(c>='0' && c<='9'));\
  var=atoi(q);                               \
  r=q;                                       \
  do { c=*++q; } while ( (c>='0' && c<='9'));\
  d=*q;                                      \
  i=sprintf(r, "%d", var-(var&7));           \
  r+=i;                                      \
  while (r!=q) *r++=' ';                     \
  *q=d;

  Read_and_modify(width)
  Read_and_modify(height)

  c=width&7;  cl=c/2, cr=c-cl;
  d=height&7; ct=d/2, cb=d-ct;
  printf("Width=%d, height=%d\n"
	 "Cutting off %d and %d from top and bottom, %d and %d from left and right\n",width,height,ct,cb,cl,cr);
  j=fsize-width*height;
  i=j-(q-p); if (i<0 || i>300) printf("Either header is too big or the image is invalid\n"), exit(1);

  q=r=p+j;
  r+=width*ct;
  width-=c;
  height-=d;
  for (i=0; i<height; i++) {
	r+=cl;
	for (j=0; j<width; j++) *q++=*r++;
	r+=cr;
  }
  i=fwrite(p, 1, q-p, out); if (i!=q-p) printf("can't write to outputfile\n"), exit(1);
  fclose(out);
  free(p);
  return 0;
}
